function [D,diff] = makeDiff2(Y,delta)
%
% make difference matrix of all pairs, with censoring (delta==1) 
% Correcting for tied data (if Y=Y', Y',Y then Y<Y'' and Y<Y'')
%

n = length(Y);
if nargin==1, delta = zeros(n,1); end % NO CENSORING
[Y,si] = sort(Y);
if not(isequal(si(:),(1:n)')), error('sort before invoking makeDiff'); end

% start with first event
e1 = 1; %min(find(delta==0)); % find first event
ne = n - e1;
nd = ne;
D = zeros(nd,n);
diff = zeros(nd,1);

% LOOP
t = 1;
eve = e1;
for i = 1:ne,
    ada = e1+i; % next comparison ...
    lower = find(Y(1:(ada-1))<Y(ada)-1e-6);
    %lower = find( abs(Y(lower)-Y(max(lower)))<1e-6)
    eves  = lower(find(delta(lower)==0));
    for j=1:length(eves),
        if t>nd, nd = nd+ne; 
            D=[D;zeros(ne,n)]; diff = [diff;zeros(ne,1)]; end % MEM allocation
        D(t,eves(j)) = -1;
        D(t,ada) = 1;   
        diff(t) = Y(ada) - Y(eve);
        t = t+1;
    end
end
D = D(1:t-1,:);
diff = diff(1:t-1,:);
