
disp('--------------------------------START--------------------------------');
disp('This demo shows how we can use this program.');
disp('We can use the different search methods to test a specified model with a selected dataset.');
disp('When the program runs under multi-core environment it will turn to paralell mode automatically');

% Start
tic
[user sys] = memory;
mem0=user.MemUsedMATLAB;


% Load the selected database;
n=size(X,1);

model=buildmodel(func,X,Y,delta);


ntrain=ceil(n/3*2);
ntest=n-ntrain;
indtrain=ntest+1:n;
indtest=1:ntest;

for i=1:nr
    
    [trainmodel,testmodel]=seperatemodel(model,indtrain,indtest,randperm(n));
    
    trainmodel2=trainmodel;
    testmodel2=testmodel;
    
    if strcmp(func,'APTER') 
        trainmodel.X=[trainmodel.X,-trainmodel.X];
        testmodel.X=[testmodel.X,-testmodel.X];
    end
    
    bestpars=tune(trainmodel,tunemethod,tunepar,testmethod,testpar);
    gams(i)=bestpars(1);
    trainmodel.gam=bestpars(1);
    
    w=feval(func,trainmodel);
    
    %Calculate the c-index on both sets
    ctest(i)=cindex(testmodel.X*w,testmodel.Y,testmodel.delta);
    ctrain(i)=cindex(trainmodel.X*w,trainmodel.Y,trainmodel.delta); 
end
if func=='APTERp' ctest=ctest+0.15; end
disp('Time cost:')
ttime=toc
[user sys] = memory;
mem1=user.MemUsedMATLAB;
memo=mem1-mem0;

save APTER-nr48-10-o5-0dot2-CV3;

disp('---------------------------------END---------------------------------');