global dataset tunemethod tunepar testmethod testpar nr func
dataset='sorliedataorig'; % Dataset
tunemethod='linesearch'; % Tune method
tunepar={-10,5,0.5,0.4}; % Tune parameters (search range/initial values)b
testmethod='CV'; % Test method
testpar={3}; % Test parameters
nr=50;

load(dataset);
d=size(X,2);
ep=10;
ml=fix(log2(d/ep));
m=power(2,(0:ml))*ep;
m(length(m)+1)=d;

for ii=1:length(m)
func='APTERp'; % Model function
load(dataset);
X=X(:,1:size(X,2)-m(ii));
demoapter;
c0(ii)=median(ctest);
t0(ii)=ttime;
m0(ii)=memo;

func='minlipl1'; % Model function
load(dataset);
X=X(:,1:size(X,2)-m(ii));
demoapter;
c1(ii)=median(ctest);
t1(ii)=ttime;
m1(ii)=memo;

func='minlipp'; % Model function
load(dataset);
X=X(:,1:size(X,2)-m(ii));
demoapter;
c2(ii)=median(ctest);
t2(ii)=ttime;
m2(ii)=memo;

func='model2p2'; % Model function
load(dataset);
X=X(:,1:size(X,2)-m(ii));
demo;
c3(ii)=ctest;
t3(ii)=ttime;
m3(ii)=memo;
end

figure;
plot(c0);
hold all;
plot(c1);
hold all;
plot(c2);
hold all;
plot(c3);
set(gca,'XTick',1:length(m)) 
set(gca,'XTicklabel',m)
legend('APTER_p','PH-L1','MINLIP_p','MODEL2')
title('C-index')

figure;
plot(t0);
hold all;
plot(t1);
hold all;
plot(t2);
hold all;
plot(t3);
set(gca,'XTick',1:length(m)) 
set(gca,'XTicklabel',m)
legend('APTER_p','PH-L1','MINLIP_p','MODEL2')
title('Time cost')


figure;
plot(m0);
hold all;
plot(m1);
hold all;
plot(m2);
hold all;
plot(m3);
set(gca,'XTick',1:length(m)) 
set(gca,'XTicklabel',m)
legend('APTER_p','PH-L1','MINLIP_p','MODEL2')
title('Memory cost')

figure;
boxplot([x1,x2,x3,x4,x5,x6],'labels',{'RankBoost','APTERp','Pen-L1','Pen-L2','ISIS-APTERp','ISIS-SCAD'})
title('Boxplot on FL' )