function [alpha,D,Yt,Yh] = minlip_kernel(X,Y,delta,C,kernel,par,Xt)
%
% duale  minlip
% delta =1: censoring
%
%   [alpha,D,Yt,Yh] = minlip_kernel(X,Y,delta,C,kernel,par,Xt)
%

[n,d] = size(X);
[Y,si] = sort(Y);
X = X(si,:);
delta = delta(si);

%%%%%%%%%%
% build D %
%%%%%%%%%% 

D = makediff3(Y,delta);
ne = size(D,1);

% solver
H = D*kernel_matrix(X,kernel,par)*D';
A = [-D'; D'];
f = D*Y;
b = [C*(1-delta); C*ones(n,1)];
lb = zeros(1,ne-1);
alpha = quadprog(H,-f, A,b,[],[],lb);

% linear
%w = X'*D'*alpha
L = alpha'*H*alpha;


% output
if nargout>2,
    Yt = kernel_matrix(Xt,kernel,par,X)*D'*alpha;
end;
if nargout>3,
    Yh = kernel_matrix(X,kernel,par)*D'*alpha;
    Yh(si)  = Yh;
end
%plot(Yh,Y,'.'); drawnow


